/**
 * string-remove-duplicate-heads-tails
 * Detect and (recursively) remove head and tail wrappings around the input string
 * Version: 5.0.5
 * Author: Roy Revelt, Codsen Ltd
 * License: MIT
 * Homepage: https://codsen.com/os/string-remove-duplicate-heads-tails/
 */

import e from"lodash.isplainobject";import{arrayiffy as t}from"arrayiffy-if-string";import{matchRightIncl as r,matchLeftIncl as i}from"string-match-left-right";import{Ranges as s}from"ranges-push";import{rApply as n}from"ranges-apply";import{trimSpaces as a}from"string-trim-spaces-only";const o="5.0.5",h={heads:["{{"],tails:["}}"]};function l(o,h){const l=Object.prototype.hasOwnProperty;if(void 0===o)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if("string"!=typeof o)return o;if(h&&!e(h))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof h}!`);const c={...h};if(c&&l.call(c,"heads")){if(!t(c.heads).every((e=>"string"==typeof e||Array.isArray(e))))throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The opts.heads contains elements which are not string-type!");"string"==typeof c.heads&&(c.heads=t(c.heads))}if(c&&l.call(c,"tails")){if(!t(c.tails).every((e=>"string"==typeof e||Array.isArray(e))))throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The opts.tails contains elements which are not string-type!");"string"==typeof c.tails&&(c.tails=t(c.tails))}const p=a(o).res;if(0===p.length)return o;o=p;const f={heads:["{{"],tails:["}}"],...c};f.heads=f.heads.map((e=>e.trim())),f.tails=f.tails.map((e=>e.trim()));let m=!1,g=!1;const u=new s({limitToBeAddedWhitespace:!0}),d=new s({limitToBeAddedWhitespace:!0});let y=!0,w=!0,b="";function B(e,t){let i;if(!r(e,0,t.heads,{trimBeforeMatching:!0,cb:(e,t,r)=>(i=r,!0)}))return e;return r(e,i,t.tails,{trimBeforeMatching:!0,cb:(e,t,r)=>(i=r,!0)})?e.slice(i):e}for(;o!==B(o,f);)o=a(B(o,f)).res;function T(e,t){let r;if(!i(e,e.length-1,t.tails,{trimBeforeMatching:!0,cb:(e,t,i)=>(r=i,!0)})||!r)return e;return i(e,r,t.heads,{trimBeforeMatching:!0,cb:(e,t,i)=>(r=i,!0)})?e.slice(0,r+1):e}for(;o!==T(o,f);)o=a(T(o,f)).res;if(!(f.heads.length&&r(o,0,f.heads,{trimBeforeMatching:!0})&&f.tails.length&&i(o,o.length-1,f.tails,{trimBeforeMatching:!0})))return a(o).res;for(let e=0,t=o.length;e<t;e++)if(""===o[e].trim());else{let t;if(r(o,e,f.heads,{trimBeforeMatching:!0,cb:(e,r,i)=>(t=i,!0)})&&t){let i;w=!0,y&&(y=!0);r(o,t,f.tails,{trimBeforeMatching:!0,cb:(e,t,r)=>(i=r,!0)})&&u.push(e,i),d.current()&&m&&"tails"!==b&&u.push(d.current()),m||d.current()&&(u.push(d.current()),d.wipe()),d.push(e,t),b="heads",e=t-1;continue}if(r(o,e,f.tails,{trimBeforeMatching:!0,cb:(e,r,i)=>(t=Number.isInteger(i)?i:o.length,!0)})&&t){w=!0,y?("heads"===b&&d.wipe(),y=!1):d.push(e,t),b="tails",e=t-1;continue}y&&(y=!0),w&&!m?(m=!0,w=!1):w&&!g?(g=!0,y=!0,w=!1,"heads"===b&&d.wipe()):w&&g&&d.wipe()}return d.current()&&u.push(d.current()),u.current()?n(o,u.current()).trim():o.trim()}export{h as defaults,l as remDup,o as version};
